
Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #581

oss4: fix high CPU usage (infinite loop) on pause.

October 19, 2015 08:26 - Dmitry Vagin

Status: Closed Start date: October 19, 2015

Priority: Minor Due date:  

Assignee:  % Done: 100%

Category: core Estimated time: 0.00 hour

Target version: 3.7   

Affects version:    

Description

Infinite loop in oss4 when music on pause.

History

#1 - October 19, 2015 21:08 - John Lindgren

It would be more helpful if you posted steps to reproduce the problem instead of a huge patch with no explanation of what it does.

#2 - October 19, 2015 21:46 - Dmitry Vagin

for playing music do loop { write_audio(); period_wait(); }

old code:

period_wait = poll 2 descriptors #1 pipe descriptor #2 /dev/pcm descriptor (all descriptors in nonblock mode),

on normal play = all ok, but on pause poll not wait descriptor #2 always ready for write (infinite loop).

new code:

period_wait check if paused when wait pthread_cond_wait(), and /dev/pcm descriptor in block mode (poll not need).

pipe not need it replace pthread condition.

#3 - October 19, 2015 21:51 - Dmitry Vagin

- File oss.h added

Little update for oss.h

#4 - October 19, 2015 22:37 - John Lindgren

Blocking mode is not an option since write_audio() needs to return immediately.  So your patch will not be accepted as-is.  Please post steps to

reproduce the problem, so that we can work towards a viable solution.

#5 - October 20, 2015 07:07 - Dmitry Vagin

John Lindgren wrote:

Blocking mode is not an option since write_audio() needs to return immediately.  So your patch will not be accepted as-is.

 

In what situations write_audio() needs to return immediately?

Please post steps to reproduce the problem, so that we can work towards a viable solution.
Pause playing music and problem reproduce.

#6 - October 20, 2015 07:10 - Dmitry Vagin

fd in nonblock mode

poll(fd);

write(fd);

==

fd in block mode

write(fd)

#7 - October 20, 2015 14:52 - Dmitry Vagin

- File oss.cc added

- File oss.h added

updated patch with poll().

#8 - October 20, 2015 19:52 - John Lindgren

The new patch still breaks drain() because you removed poll_wake().  Read the documentation and stop making changes without understanding what

was there before.

#9 - October 20, 2015 19:52 - John Lindgren

Dmitry Vagin wrote:

In what situations write_audio() needs to return immediately?

 

Always.

#10 - October 20, 2015 20:11 - Dmitry Vagin

John Lindgren wrote:

The new patch still breaks drain() because you removed poll_wake().  Read the documentation and stop making changes without understanding

what was there before.

 

which documentation to read?
#11 - October 21, 2015 04:52 - John Lindgren

Look at libaudcore/plugin.h for starters.

#12 - October 21, 2015 06:11 - John Lindgren

- Category set to core

- Status changed from New to Closed

- Target version set to 3.7

- % Done changed from 0 to 100

Actually this can be fixed more cleanly in core.

Files

oss.cc 3.94 KB October 19, 2015 Dmitry Vagin

oss.h 504 Bytes October 19, 2015 Dmitry Vagin

oss.h 485 Bytes October 19, 2015 Dmitry Vagin

oss.cc 3.94 KB October 20, 2015 Dmitry Vagin

oss.h 542 Bytes October 20, 2015 Dmitry Vagin
